libzypp: zypp::ResPool Class Reference

libzypp 17.38.5

zypp::ResPool Class Reference

Global ResObject pool. More...

`#include <zypp/ResPool.h>`

## Classes
class | EstablishedStates
| A copy of the Pools initial ValidateValues of pseudo installed items. More...

## Public Types
using | value_type = PoolItem
| PoolItem
using | size_type = pool::PoolTraits::size_type
using | const_iterator = pool::PoolTraits::const_iterator
using | repository_iterator = pool::PoolTraits::repository_iterator

## Public Member Functions
ResPoolProxy | proxy () const
| preliminary
Resolver & | resolver () const
| The Resolver.
const SerialNumber & | serial () const
| The pools serial number.
bool | empty () const
size_type | size () const
Iterate over all PoolItems (all kinds).
const_iterator | begin () const
const_iterator | end () const
PoolItem | find (const sat::Solvable &slv_r) const
| Return the corresponding PoolItem.
PoolItem | find (const ResObject::constPtr &resolvable_r) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
Iterate over all PoolItems matching a \c TFilter.
template<class TFilter>
filter_iterator< TFilter, const_iterator > | filterBegin (const TFilter &filter_r) const
template<class TFilter>
filter_iterator< TFilter, const_iterator > | filterEnd (const TFilter &filter_r) const
template<class TFilter>
Iterable< filter_iterator< TFilter, const_iterator > > | filter (const TFilter &filter_r) const
Iterate over all PoolItems by status.
Simply pass the ResStatus predicate you want to use as filter: // iterate over all orphaned items: for_( it, pool.byStatusBegin(&ResStatus::isOrphaned), pool.byStatusEnd(&ResStatus::isOrphaned) ) {...} for_ #define for_(IT, BEG, END) Convenient for-loops using iterator. Definition Easy.h:27 zypp::ResStatus::isOrphaned bool isOrphaned() const Definition ResStatus.h:194 zypp::pool Definition ByIdent.h:24 Or use filter::ByStatus in more complex queries: // iterate over all (orphaned and recommended) items: functor::Chain<filter::ByStatus,filter::ByStatus> myfilter( filter::ByStatus(&ResStatus::isOrphaned), filter::ByStatus(&ResStatus::isRecommended) ); for_( it, pool.filterBegin(myfilter), pool.filterEnd(myfilter) ) { ... } zypp::ResStatus::isRecommended bool isRecommended() const Definition ResStatus.h:188 zypp::filter::ByStatus Filter solvables according to their status. Definition Filter.h:143 zypp::functor::Chain Logical functor chaining TACondition AND TBCondition. Definition Functional.h:165
filter_iterator< filter::ByStatus, const_iterator > | byStatusBegin (const filter::ByStatus &filter_r) const
filter_iterator< filter::ByStatus, const_iterator > | byStatusEnd (const filter::ByStatus &filter_r) const
Iterable< filter_iterator< filter::ByStatus, const_iterator > > | byStatus (const filter::ByStatus &filter_r) const
Iterate over all Repositories that contribute ResObjects.
size_type | knownRepositoriesSize () const
repository_iterator | knownRepositoriesBegin () const
repository_iterator | knownRepositoriesEnd () const
Repository | reposFind (const std::string &alias_r) const
| Find a Repository named `alias_r`.
Iterable< repository_iterator > | knownRepositories () const
Handle locale support.
A filter::ByLocaleSupport is provided to iterate over all items supporting a specific locale. See also sat::LocaleSupport for a more convenient interface. ResPool pool( ResPool::instance() ); filter::ByLocaleSupport f( Locale("de") ); for_( it, pool.filterBegin(f), pool.filterEnd(f) ) { MIL << *it << endl; // supporting "de" } f = filter::ByLocaleSupport( pool.getRequestedLocales() ); for_( it, pool.filterBegin(f), pool.filterEnd(f) ) { MIL << *it << endl; // supporting any requested locale } MIL #define MIL Definition Logger.h:100 zypp::Locale 'Language[_Country]' codes. Definition Locale.h:51 zypp::ResPool::ResPool ResPool(pool::PoolTraits::Impl_Ptr impl_r) Ctor. Definition ResPool.cc:49 zypp::ResPool::instance static ResPool instance() Singleton ctor. Definition ResPool.cc:38 zypp::filter::ByLocaleSupport Filter solvables according to their locale support. Definition Filter.h:64
void | setRequestedLocales (const LocaleSet &locales_r)
| Set the requested locales.
bool | addRequestedLocale (const Locale &locale_r)
| Add one Locale to the set of requested locales.
bool | eraseRequestedLocale (const Locale &locale_r)
| Erase one Locale from the set of requested locales.
const LocaleSet & | getRequestedLocales () const
| Return the requested locales.
bool | isRequestedLocale (const Locale &locale_r) const
| Whether this Locale is in the set of requested locales.
const LocaleSet & | getAvailableLocales () const
| Get the set of available locales.
bool | isAvailableLocale (const Locale &locale_r) const
| Whether this Locale is in the set of available locales.

## Static Public Member Functions
static ResPool | instance ()
| Singleton ctor.

## Friends
std::ostream & | operator<< (std::ostream &str, const ResPool &obj)

## Related Symbols
(Note that these are not member symbols.)
std::ostream & | operator<< (std::ostream &str, const ResPool &obj) ZYPP_API
| Stream output.

## Iterate over all PoolItems of a certain name and kind.
using | ByIdent = pool::ByIdent
using | byIdent_iterator = pool::PoolTraits::byIdent_iterator
byIdent_iterator | byIdentBegin (const ByIdent &ident_r) const
byIdent_iterator | byIdentBegin (ResKind kind_r, IdString name_r) const
byIdent_iterator | byIdentBegin (ResKind kind_r, const C_Str &name_r) const
template<class TRes>
byIdent_iterator | byIdentBegin (IdString name_r) const
template<class TRes>
byIdent_iterator | byIdentBegin (const C_Str &name_r) const
byIdent_iterator | byIdentBegin (const PoolItem &pi_r) const
| Derive name and kind from PoolItem.
byIdent_iterator | byIdentBegin (sat::Solvable slv_r) const
| Derive name and kind from sat::Solvable.
byIdent_iterator | byIdentBegin (IdString ident_r) const
| Takes a sat::Solvable::ident string.
byIdent_iterator | byIdentEnd (const ByIdent &ident_r) const
byIdent_iterator | byIdentEnd (ResKind kind_r, IdString name_r) const
byIdent_iterator | byIdentEnd (ResKind kind_r, const C_Str &name_r) const
template<class TRes>
byIdent_iterator | byIdentEnd (IdString name_r) const
template<class TRes>
byIdent_iterator | byIdentEnd (const C_Str &name_r) const
byIdent_iterator | byIdentEnd (const PoolItem &pi_r) const
| Derive name and kind from PoolItem.
byIdent_iterator | byIdentEnd (sat::Solvable slv_r) const
| Derive name and kind from sat::Solvable.
byIdent_iterator | byIdentEnd (IdString ident_r) const
| Takes a sat::Solvable::ident string.
Iterable< byIdent_iterator > | byIdent (const ByIdent &ident_r) const
Iterable< byIdent_iterator > | byIdent (const ResKind &kind_r, IdString name_r) const
Iterable< byIdent_iterator > | byIdent (const ResKind &kind_r, const C_Str &name_r) const
template<class TRes>
Iterable< byIdent_iterator > | byIdent (IdString name_r) const
template<class TRes>
Iterable< byIdent_iterator > | byIdent (const C_Str &name_r) const
Iterable< byIdent_iterator > | byIdent (const PoolItem &pi_r) const
Iterable< byIdent_iterator > | byIdent (sat::Solvable slv_r) const
Iterable< byIdent_iterator > | byIdent (IdString ident_r) const

## Iterate over all ResObjects of a certain kind.
using | ByKind = filter::ByKind
using | byKind_iterator = filter_iterator<ByKind, const_iterator>
byKind_iterator | byKindBegin (const ResKind &kind_r) const
template<class TRes>
byKind_iterator | byKindBegin () const
byKind_iterator | byKindEnd (const ResKind &kind_r) const
template<class TRes>
byKind_iterator | byKindEnd () const
Iterable< byKind_iterator > | byKind (const ResKind &kind_r) const
template<class TRes>
Iterable< byKind_iterator > | byKind () const

## Iterate over all ResObjects with a certain name (all kinds).
using | ByName = zypp::resfilter::ByName
using | byName_iterator = filter_iterator<ByName, const_iterator>
byName_iterator | byNameBegin (const std::string &name_r) const
byName_iterator | byNameEnd (const std::string &name_r) const
Iterable< byName_iterator > | byName (const std::string &name_r) const

## Misc Data.
using | ChangedPseudoInstalled = EstablishedStates::ChangedPseudoInstalled
| Map holding pseudo installed items where current and established status differ.
EstablishedStates | establishedStates () const
| Factory for EstablishedStates.
ChangedPseudoInstalled | changedPseudoInstalled () const
| Return all pseudo installed items whose current state differs from their initial one.

## Handle hard locks (e.g set from /etc/zypp/locks).
As this kind of lock is query based, it's quite expensive. These queries are re-evaluated when adding new repos to the pool.
using | HardLockQueries = pool::PoolTraits::HardLockQueries
using | hardLockQueries_iterator = pool::PoolTraits::hardLockQueries_iterator
RW_pointer< pool::PoolTraits::Impl > | _pimpl
| Access to implementation.
bool | hardLockQueriesEmpty () const
size_type | hardLockQueriesSize () const
hardLockQueries_iterator | hardLockQueriesBegin () const
hardLockQueries_iterator | hardLockQueriesEnd () const
Iterable< hardLockQueries_iterator > | hardLockQueries () const
void | setHardLockQueries (const HardLockQueries &newLocks_r)
| Set a new set of queries.
void | getHardLockQueries (HardLockQueries &activeLocks_r)
| Suggest a new set of queries based on the current selection.
const pool::PoolTraits::ItemContainerT & | store () const
const pool::PoolTraits::Id2ItemT & | id2item () const
| ResPool (pool::PoolTraits::Impl_Ptr impl_r)
| Ctor.

## Detailed Description

Global ResObject pool.

Explicitly shared singleton.

Note
  Filter iterators provided by ResPool are intended to operate on internal index tables for faster access. If the the index is not yet implemented, they are realized as an ordinary filter iterator. Do not provide filter iterators here, if there is no index table for it.

For most (*Begin,*End) iterator-pairs there's also an Iterable provided, so you can use then in range-based for loops:

// classic:
for_( it, pool.filterBegin(myfilter), pool.filterEnd(myfilter) )
{ ... }
// range based:
for ( const PoolItem & pi : pool.filter(myfilter) )
{ ... }
zypp::PoolItem
Combining sat::Solvable and ResStatus.
Definition PoolItem.h:51
I tagged the byName iterator as deprecated, so the compiler tells you
where it is used. Please review the code and check whether byIdent is
an appropriate replacement.
--
The 'old' zypp pool internally maintained a byName index, so it was a
fast way to iterate the pool by name and filter by kind to visit e.g.
all packages named foo:
invokeOnEach( pool.byNameBegin( name ), pool.byNameEnd( name ),
resfilter::ByKind( kind ),
action() );
for_( it, pool.byNameBegin( name ), pool.byNameEnd( name ) )
{
if ( (*it)->kind() == kind )
{
...
}
}
This is no longer true.
In contrary, byName now is a 'quite expensive' iteration. It's faster to
rewrite these loops using byIdent (and no filter):
invokeOnEach( pool.byIdentBegin( kind, name ),
pool.byIdentEnd( kind, name ),
action() );
for_( it, pool.byIdentBegin( kind, name ), pool.byNameEnd( kind, name ) )
{
...
}
How to construct the byIdent iterator:
ResPool::byIdentBegin( poolItem ) // using this poolItems kind and name
ResPool::byIdentBegin( kind, name ) // explicit kind and name
ResPool::byIdentBegin<Package>( name ) // or templated kind
--
If you prefer using iterator in a for' loop, but dislike to figure out
the exact type of the iterator, you may find the 'for_' macro convenient:
#include "zypp/base/Easy.h"
for_( it, pool.byIdentBegin( kind, name ),
pool.byIdentEnd( kind, name ) )
{
PoolItem copy = *it;
}
instead of:
for ( ResPool::byIdent_iterator it = pool.byIdentBegin( kind, name ),
end = pool.byIdentEnd( kind, name );
it != end, ++it )
{
PoolItem copy = *it;
}

Definition at line 61 of file ResPool.h.

## Member Typedef Documentation

## ◆ value_type

using zypp::ResPool::value_type = PoolItem

PoolItem

Definition at line 67 of file ResPool.h.

## ◆ size_type

using zypp::ResPool::size_type = pool::PoolTraits::size_type

Definition at line 68 of file ResPool.h.

## ◆ const_iterator

using zypp::ResPool::const_iterator = pool::PoolTraits::const_iterator

Definition at line 69 of file ResPool.h.

## ◆ repository_iterator

using zypp::ResPool::repository_iterator = pool::PoolTraits::repository_iterator

Definition at line 70 of file ResPool.h.

## ◆ ByIdent

using zypp::ResPool::ByIdent = pool::ByIdent

Definition at line 164 of file ResPool.h.

## ◆ byIdent_iterator

using zypp::ResPool::byIdent_iterator = pool::PoolTraits::byIdent_iterator

Definition at line 165 of file ResPool.h.

## ◆ ByKind

using zypp::ResPool::ByKind = filter::ByKind

Definition at line 259 of file ResPool.h.

## ◆ byKind_iterator

using zypp::ResPool::byKind_iterator = filter_iterator<ByKind, const_iterator>

Definition at line 260 of file ResPool.h.

## ◆ ByName

using zypp::ResPool::ByName = zypp::resfilter::ByName

Definition at line 287 of file ResPool.h.

## ◆ byName_iterator

using zypp::ResPool::byName_iterator = filter_iterator<ByName, const_iterator>

Definition at line 288 of file ResPool.h.

## ◆ ChangedPseudoInstalled

using zypp::ResPool::ChangedPseudoInstalled = EstablishedStates::ChangedPseudoInstalled

Map holding pseudo installed items where current and established status differ.

Definition at line 342 of file ResPool.h.

## ◆ HardLockQueries

using zypp::ResPool::HardLockQueries = pool::PoolTraits::HardLockQueries

Definition at line 439 of file ResPool.h.

## ◆ hardLockQueries_iterator

using zypp::ResPool::hardLockQueries_iterator = pool::PoolTraits::hardLockQueries_iterator

Definition at line 440 of file ResPool.h.

## Constructor & Destructor Documentation

## ◆ ResPool()

zypp::ResPool::ResPool | ( | pool::PoolTraits::Impl_Ptr | impl_r | ) |
| private

Ctor.

Definition at line 49 of file ResPool.cc.

## Member Function Documentation

## ◆ instance()

ResPool zypp::ResPool::instance | ( |  | ) |
| static

Singleton ctor.

Definition at line 38 of file ResPool.cc.

## ◆ proxy()

ResPoolProxy zypp::ResPool::proxy | ( |  | ) | const

preliminary

Definition at line 59 of file ResPool.cc.

## ◆ resolver()

Resolver & zypp::ResPool::resolver | ( |  | ) | const

The Resolver.

Definition at line 62 of file ResPool.cc.

## ◆ serial()

const SerialNumber & zypp::ResPool::serial | ( |  | ) | const

The pools serial number.

Changing whenever the whenever the content changes. (Resolvables or Dependencies).

Definition at line 65 of file ResPool.cc.

## ◆ empty()

bool zypp::ResPool::empty | ( |  | ) | const

Definition at line 68 of file ResPool.cc.

## ◆ size()

ResPool::size_type zypp::ResPool::size | ( |  | ) | const

Definition at line 71 of file ResPool.cc.

## ◆ begin()

const_iterator zypp::ResPool::begin | ( |  | ) | const
| inline

Definition at line 98 of file ResPool.h.

## ◆ end()

const_iterator zypp::ResPool::end | ( |  | ) | const
| inline

Definition at line 101 of file ResPool.h.

## ◆ find() [1/2]

PoolItem zypp::ResPool::find | ( | const sat::Solvable & | slv_r | ) | const

Return the corresponding PoolItem.

Pool and sat pool should be in sync. Returns an empty PoolItem if there is no corresponding PoolItem.

See also
  PoolItem::satSolvable.

Definition at line 74 of file ResPool.cc.

## ◆ find() [2/2]

PoolItem zypp::ResPool::find | ( | const ResObject::constPtr & | resolvable_r | ) | const
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 113 of file ResPool.h.

## ◆ filterBegin()

template<class TFilter>

filter_iterator< TFilter, const_iterator > zypp::ResPool::filterBegin | ( | const TFilter & | filter_r | ) | const
| inline

Definition at line 120 of file ResPool.h.

## ◆ filterEnd()

template<class TFilter>

filter_iterator< TFilter, const_iterator > zypp::ResPool::filterEnd | ( | const TFilter & | filter_r | ) | const
| inline

Definition at line 124 of file ResPool.h.

## ◆ filter()

template<class TFilter>

Iterable< filter_iterator< TFilter, const_iterator > > zypp::ResPool::filter | ( | const TFilter & | filter_r | ) | const
| inline

Definition at line 128 of file ResPool.h.

## ◆ byStatusBegin()

filter_iterator< filter::ByStatus, const_iterator > zypp::ResPool::byStatusBegin | ( | const filter::ByStatus & | filter_r | ) | const
| inline

Definition at line 151 of file ResPool.h.

## ◆ byStatusEnd()

filter_iterator< filter::ByStatus, const_iterator > zypp::ResPool::byStatusEnd | ( | const filter::ByStatus & | filter_r | ) | const
| inline

Definition at line 154 of file ResPool.h.

## ◆ byStatus()

Iterable< filter_iterator< filter::ByStatus, const_iterator > > zypp::ResPool::byStatus | ( | const filter::ByStatus & | filter_r | ) | const
| inline

Definition at line 157 of file ResPool.h.

## ◆ byIdentBegin() [1/8]

byIdent_iterator zypp::ResPool::byIdentBegin | ( | const ByIdent & | ident_r | ) | const
| inline

Definition at line 167 of file ResPool.h.

## ◆ byIdentBegin() [2/8]

byIdent_iterator zypp::ResPool::byIdentBegin | ( | ResKind | kind_r,
|  | IdString | name_r ) const
| inline

Definition at line 173 of file ResPool.h.

## ◆ byIdentBegin() [3/8]

byIdent_iterator zypp::ResPool::byIdentBegin | ( | ResKind | kind_r,
|  | const C_Str & | name_r ) const
| inline

Definition at line 176 of file ResPool.h.

## ◆ byIdentBegin() [4/8]

template<class TRes>

byIdent_iterator zypp::ResPool::byIdentBegin | ( | IdString | name_r | ) | const
| inline

Definition at line 180 of file ResPool.h.

## ◆ byIdentBegin() [5/8]

template<class TRes>

byIdent_iterator zypp::ResPool::byIdentBegin | ( | const C_Str & | name_r | ) | const
| inline

Definition at line 184 of file ResPool.h.

## ◆ byIdentBegin() [6/8]

byIdent_iterator zypp::ResPool::byIdentBegin | ( | const PoolItem & | pi_r | ) | const
| inline

Derive name and kind from PoolItem.

Definition at line 188 of file ResPool.h.

## ◆ byIdentBegin() [7/8]

byIdent_iterator zypp::ResPool::byIdentBegin | ( | sat::Solvable | slv_r | ) | const
| inline

Derive name and kind from sat::Solvable.

Definition at line 191 of file ResPool.h.

## ◆ byIdentBegin() [8/8]

byIdent_iterator zypp::ResPool::byIdentBegin | ( | IdString | ident_r | ) | const
| inline

Takes a sat::Solvable::ident string.

Definition at line 194 of file ResPool.h.

## ◆ byIdentEnd() [1/8]

byIdent_iterator zypp::ResPool::byIdentEnd | ( | const ByIdent & | ident_r | ) | const
| inline

Definition at line 198 of file ResPool.h.

## ◆ byIdentEnd() [2/8]

byIdent_iterator zypp::ResPool::byIdentEnd | ( | ResKind | kind_r,
|  | IdString | name_r ) const
| inline

Definition at line 204 of file ResPool.h.

## ◆ byIdentEnd() [3/8]

byIdent_iterator zypp::ResPool::byIdentEnd | ( | ResKind | kind_r,
|  | const C_Str & | name_r ) const
| inline

Definition at line 207 of file ResPool.h.

## ◆ byIdentEnd() [4/8]

template<class TRes>

byIdent_iterator zypp::ResPool::byIdentEnd | ( | IdString | name_r | ) | const
| inline

Definition at line 211 of file ResPool.h.

## ◆ byIdentEnd() [5/8]

template<class TRes>

byIdent_iterator zypp::ResPool::byIdentEnd | ( | const C_Str & | name_r | ) | const
| inline

Definition at line 215 of file ResPool.h.

## ◆ byIdentEnd() [6/8]

byIdent_iterator zypp::ResPool::byIdentEnd | ( | const PoolItem & | pi_r | ) | const
| inline

Derive name and kind from PoolItem.

Definition at line 219 of file ResPool.h.

## ◆ byIdentEnd() [7/8]

byIdent_iterator zypp::ResPool::byIdentEnd | ( | sat::Solvable | slv_r | ) | const
| inline

Derive name and kind from sat::Solvable.

Definition at line 222 of file ResPool.h.

## ◆ byIdentEnd() [8/8]

byIdent_iterator zypp::ResPool::byIdentEnd | ( | IdString | ident_r | ) | const
| inline

Takes a sat::Solvable::ident string.

Definition at line 225 of file ResPool.h.

## ◆ byIdent() [1/8]

Iterable< byIdent_iterator > zypp::ResPool::byIdent | ( | const ByIdent & | ident_r | ) | const
| inline

Definition at line 229 of file ResPool.h.

## ◆ byIdent() [2/8]

Iterable< byIdent_iterator > zypp::ResPool::byIdent | ( | const ResKind & | kind_r,
|  | IdString | name_r ) const
| inline

Definition at line 232 of file ResPool.h.

## ◆ byIdent() [3/8]

Iterable< byIdent_iterator > zypp::ResPool::byIdent | ( | const ResKind & | kind_r,
|  | const C_Str & | name_r ) const
| inline

Definition at line 235 of file ResPool.h.

## ◆ byIdent() [4/8]

template<class TRes>

Iterable< byIdent_iterator > zypp::ResPool::byIdent | ( | IdString | name_r | ) | const
| inline

Definition at line 239 of file ResPool.h.

## ◆ byIdent() [5/8]

template<class TRes>

Iterable< byIdent_iterator > zypp::ResPool::byIdent | ( | const C_Str & | name_r | ) | const
| inline

Definition at line 243 of file ResPool.h.

## ◆ byIdent() [6/8]

Iterable< byIdent_iterator > zypp::ResPool::byIdent | ( | const PoolItem & | pi_r | ) | const
| inline

Definition at line 246 of file ResPool.h.

## ◆ byIdent() [7/8]

Iterable< byIdent_iterator > zypp::ResPool::byIdent | ( | sat::Solvable | slv_r | ) | const
| inline

Definition at line 249 of file ResPool.h.

## ◆ byIdent() [8/8]

Iterable< byIdent_iterator > zypp::ResPool::byIdent | ( | IdString | ident_r | ) | const
| inline

Definition at line 252 of file ResPool.h.

## ◆ byKindBegin() [1/2]

byKind_iterator zypp::ResPool::byKindBegin | ( | const ResKind & | kind_r | ) | const
| inline

Definition at line 262 of file ResPool.h.

## ◆ byKindBegin() [2/2]

template<class TRes>

byKind_iterator zypp::ResPool::byKindBegin | ( |  | ) | const
| inline

Definition at line 266 of file ResPool.h.

## ◆ byKindEnd() [1/2]

byKind_iterator zypp::ResPool::byKindEnd | ( | const ResKind & | kind_r | ) | const
| inline

Definition at line 269 of file ResPool.h.

## ◆ byKindEnd() [2/2]

template<class TRes>

byKind_iterator zypp::ResPool::byKindEnd | ( |  | ) | const
| inline

Definition at line 273 of file ResPool.h.

## ◆ byKind() [1/2]

Iterable< byKind_iterator > zypp::ResPool::byKind | ( | const ResKind & | kind_r | ) | const
| inline

Definition at line 276 of file ResPool.h.

## ◆ byKind() [2/2]

template<class TRes>

Iterable< byKind_iterator > zypp::ResPool::byKind | ( |  | ) | const
| inline

Definition at line 280 of file ResPool.h.

## ◆ byNameBegin()

byName_iterator zypp::ResPool::byNameBegin | ( | const std::string & | name_r | ) | const
| inline

Definition at line 290 of file ResPool.h.

## ◆ byNameEnd()

byName_iterator zypp::ResPool::byNameEnd | ( | const std::string & | name_r | ) | const
| inline

Definition at line 293 of file ResPool.h.

## ◆ byName()

Iterable< byName_iterator > zypp::ResPool::byName | ( | const std::string & | name_r | ) | const
| inline

Definition at line 296 of file ResPool.h.

## ◆ establishedStates()

ResPool::EstablishedStates zypp::ResPool::establishedStates | ( |  | ) | const

Factory for EstablishedStates.

A few internal algorithms benefit from keeping an instance across pool content changes. User code usually want's to call changedPseudoInstalled directly.

Definition at line 77 of file ResPool.cc.

## ◆ changedPseudoInstalled()

ChangedPseudoInstalled zypp::ResPool::changedPseudoInstalled | ( |  | ) | const
| inline

Return all pseudo installed items whose current state differs from their initial one.

E.g. a Patch may become SATISFIED by updating the packages it refers to. For this to happen it does not matter whether you selected the Patch or whether you selected the individual Packages. A Patches status is computed and updated with every solver run.

Definition at line 350 of file ResPool.h.

## ◆ knownRepositoriesSize()

ResPool::size_type zypp::ResPool::knownRepositoriesSize | ( |  | ) | const

Definition at line 80 of file ResPool.cc.

## ◆ knownRepositoriesBegin()

ResPool::repository_iterator zypp::ResPool::knownRepositoriesBegin | ( |  | ) | const

Definition at line 83 of file ResPool.cc.

## ◆ knownRepositoriesEnd()

ResPool::repository_iterator zypp::ResPool::knownRepositoriesEnd | ( |  | ) | const

Definition at line 86 of file ResPool.cc.

## ◆ reposFind()

Repository zypp::ResPool::reposFind | ( | const std::string & | alias_r | ) | const

Find a Repository named `alias_r`.

Returns Repository::noRepository if there is no such Repository.

Definition at line 89 of file ResPool.cc.

## ◆ knownRepositories()

Iterable< repository_iterator > zypp::ResPool::knownRepositories | ( |  | ) | const
| inline

Definition at line 368 of file ResPool.h.

## ◆ setRequestedLocales()

void zypp::ResPool::setRequestedLocales | ( | const LocaleSet & | locales_r | ) |

Set the requested locales.

Languages to be supported by the system, e.g. language specific packages to be installed.

Definition at line 122 of file ResPool.cc.

## ◆ addRequestedLocale()

bool zypp::ResPool::addRequestedLocale | ( | const Locale & | locale_r | ) |

Add one Locale to the set of requested locales.

Return `true` if `locale_r` was newly added to the set.

Definition at line 125 of file ResPool.cc.

## ◆ eraseRequestedLocale()

bool zypp::ResPool::eraseRequestedLocale | ( | const Locale & | locale_r | ) |

Erase one Locale from the set of requested locales.

Return `false` if `locale_r` was not found in the set.

Definition at line 128 of file ResPool.cc.

## ◆ getRequestedLocales()

const LocaleSet & zypp::ResPool::getRequestedLocales | ( |  | ) | const

Return the requested locales.

See also
  setRequestedLocales

Definition at line 131 of file ResPool.cc.

## ◆ isRequestedLocale()

bool zypp::ResPool::isRequestedLocale | ( | const Locale & | locale_r | ) | const

Whether this Locale is in the set of requested locales.

Definition at line 134 of file ResPool.cc.

## ◆ getAvailableLocales()

const LocaleSet & zypp::ResPool::getAvailableLocales | ( |  | ) | const

Get the set of available locales.

This is computed from the package data so it actually represents all locales packages claim to support.

Definition at line 137 of file ResPool.cc.

## ◆ isAvailableLocale()

bool zypp::ResPool::isAvailableLocale | ( | const Locale & | locale_r | ) | const

Whether this Locale is in the set of available locales.

Definition at line 140 of file ResPool.cc.

## ◆ hardLockQueriesEmpty()

bool zypp::ResPool::hardLockQueriesEmpty | ( |  | ) | const

Definition at line 92 of file ResPool.cc.

## ◆ hardLockQueriesSize()

ResPool::size_type zypp::ResPool::hardLockQueriesSize | ( |  | ) | const

Definition at line 95 of file ResPool.cc.

## ◆ hardLockQueriesBegin()

ResPool::hardLockQueries_iterator zypp::ResPool::hardLockQueriesBegin | ( |  | ) | const

Definition at line 98 of file ResPool.cc.

## ◆ hardLockQueriesEnd()

ResPool::hardLockQueries_iterator zypp::ResPool::hardLockQueriesEnd | ( |  | ) | const

Definition at line 101 of file ResPool.cc.

## ◆ hardLockQueries()

Iterable< hardLockQueries_iterator > zypp::ResPool::hardLockQueries | ( |  | ) | const
| inline

Definition at line 447 of file ResPool.h.

## ◆ setHardLockQueries()

void zypp::ResPool::setHardLockQueries | ( | const HardLockQueries & | newLocks_r | ) |

Set a new set of queries.

The hard-locks of existing PoolItems are adjusted according to the queries. (usually called on target load)

Definition at line 104 of file ResPool.cc.

## ◆ getHardLockQueries()

void zypp::ResPool::getHardLockQueries | ( | HardLockQueries & | activeLocks_r | ) |

Suggest a new set of queries based on the current selection.

(usually remembered on commit).

Definition at line 107 of file ResPool.cc.

## ◆ store()

const pool::PoolTraits::ItemContainerT & zypp::ResPool::store | ( |  | ) | const
| private

Definition at line 111 of file ResPool.cc.

## ◆ id2item()

const pool::PoolTraits::Id2ItemT & zypp::ResPool::id2item | ( |  | ) | const
| private

Definition at line 114 of file ResPool.cc.

## Friends And Related Symbol Documentation

## ◆ operator<< [1/2]

std::ostream & operator<< | ( | std::ostream & | str,
|  | const ResPool & | obj )
| friend

Definition at line 148 of file ResPool.cc.

## ◆ operator<<() [2/2]

std::ostream & operator<< | ( | std::ostream & | str,
|  | const ResPool & | obj )
| related

Stream output.

Definition at line 148 of file ResPool.cc.

## Member Data Documentation

## ◆ _pimpl

RW_pointer<pool::PoolTraits::Impl> zypp::ResPool::_pimpl
| private

Access to implementation.

Definition at line 470 of file ResPool.h.

The documentation for this class was generated from the following files:

- zypp/ResPool.h
- zypp/ResPool.cc